/*
Illustrates Pointers 
   */
#include <stdio.h>

/* Function Protype Statement for the convert function called from
   main() -- "double *celsius" means that a memory address of a double
   variable is going to be passed to the function -- the word
   "celsius" is just a convenience for the programmer to remember what
   the function is going to do!! */
/* Note that the statement
double *celsius;
means that "celsius" is a pointer of type double.  This does not
initialize "celsius".  To do that would require a statement like:

celsius = &heat;

This would result in the pointer "celsius" pointing to the memory
location of the variable "heat".
*/
/* The "void" means that the function convert() does not return any value*/

void convert(double *celsius);

int main(void){

	double temperature = 80;
	printf("\n\t80 degrees fahrenheit (before conversion) == %f celsius",temperature);
/* Pointer arguments enable a function to access and change objects in
 * the function that calls it -- In this case, temperature in main()
 * above gets changed in the convert() function by using a pointer to
 * the memory location of temperature in main() */
/* "&temperature" means "memory address of the variable temperature"*/
	convert(&temperature);
	printf("\n\t80 degrees fahrenheit (after conversion) == %f celsius\n\n",temperature);
return(0);
}

void convert(double *celsius){

	double temp;
/* temp is set to the value pointed to by "*celsius" -- that is, "80" */
	temp = *celsius;
	temp = (temp - 32)/1.8;
/* Applying the "*" operator to a pointer -- in this case "celsius" is a
 * pointer -- yields the value stored in
 * the pointed-to object.  Here "celsius" is a pointer to the memory
 * location of temperature in the main program -- the value "80".
 * "*celsius" replaces "80" with the value in temp, or "26.6666" at the
 * memory location &temperature */
	*celsius = temp;
/* Note that there is no "return" used because the function is declared
 * as a "void" */
}
